mod Ex11a


loc rem 
  \para \bf  11. CVIČENIE Z PREDMETU ÚVOD DO DEKLARATÍVNEHO PROGRAMOVANIA 
  LS 2011/2012  \end 
  \para* \bf  ČASŤ A  \end 
  \para* http://dai.fmph.uniba.sk/courses/udp/ex/ex11.zip 

loc rem 
  \para* \it  Dátum:  \end 23. 4. 2012 
  \para* \it  Odporúčaná verzia CL:  \end \bf  5.81.20  \end 
  \para* \it  WWW stránka predmetu:  \end http://dai.fmph.uniba.sk/courses/udp/ 
  \para* \it  Kontakt:  \end udp(zavináč)lists.dai.fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované binárnym
  stromom (ex11a) a binárnym vyhľadávacím stromom (ex11b).

loc rem 
  \para \it  Literatúra.  \end 
  \para* [1] J. Kľuka. Prednášky z Úvodu do deklaratívneho programovania 
  LS 2011/2012. 
  \para http://dai.fmph.uniba.sk/courses/udp/udp-prednasky-2012.pdf 
  \para* [2] D. Guller. Poznámky k prednáškam z CL. 
  \para* [3] J. Komara and P. J. Voda. Metamathematics of Computer 
  Programming. 2001. 

loc rem 
  \para \it  Poznámka.  \end Nadpisy sú číslované podľa [1]. 

loc rem 
  \para Preskočte nasledujúce komponenty po nadpis „CVIČENIE“. 


incl Maux11

incl Mtesting11

rem 
  \para \bf  C V I Č E N I E  \end 

rem 
  \para* \bf  16. BINÁRNE STROMY  \end 

rem 
  \para* \bf  16.1. Kódovanie binárnych stromov  \end 

rem 
  \para \bf  \it  Kódovanie binárnych stromov párovacími konštruktormi 
   \end  \end Binárne stromy budeme kódovať pomocou nasledujúcich 
  párovacích \it  konštruktorov  \end. 
  \items 
   \item \para Konštruktor \ft Tex2_equiv(E,Tex0_e) \end kóduje prázdny 
         strom. 
   \item \para \header* fun/3 Nd  \end Konštruktor 
         \ft Tex2_equiv(Nd(x,l,r),Tex3_nd(x,l,r)) \end kóduje uzol stromu, 
         v ktorom je uložená hodnota \ft x \end, jeho ľavé dieťa je 
         zakódované číslom \ft l \end a pravé dieťa číslom \ft r \end. 
  \end

fun/0 E 'Tex0_e'
  E = 0,0

fun/3 Nd 'Tex3_nd'
  Nd(x,l,r) = 1,x,l,r

rem 
  \para \bf  \it  Príklad.  \end  \end Binárny strom uvedený ako príklad 
  v [1, §16.1] môžeme zakódovať napríklad takto: 
  \verbatim 
      Nd(0,Nd(1,Nd(3,E,E),Nd(4,E,E)),Nd(2,E,Nd(6,E,E)))
  \end
  \para Uvedený kód binárneho stromu sa zobrazí nasledovne: 
  \eq* 
    Nd(0,Nd(1,Nd(3,E,E),Nd(4,E,E)),Nd(2,E,Nd(6,E,E)))
  \end
  \para Tento príklad je zadefinovaný ako nasledujúca konštanta \ft T1 \end. 
  Použijeme ju na testovanie riešení úloh v tomto cvičení. 

fun/0 T1 
  T1 = Nd(0,Nd(1,Nd(3,E,E),Nd(4,E,E)),Nd(2,E,Nd(6,E,E)))

rem 
  \para \bf  \it  [CL] Diskriminácia na binárnych stromoch.  \end  \end CL 
  dokáže diskriminovať hodnoty vytvorené konštruktormi \ft E \end a 
  \ft Nd(x,l,r) \end. 
  \para* Binárne stromy budeme dekódovať \it  diskrimináciou na binárnych 
  stromoch  \end: 
  \def* 
    Tex1_cdots(t) <- t = E
    Tex1_cdots(t) <- t = Nd(x,l,r)
  \end
  \para Túto diskrimináciu môžeme tiež dosadiť do argumentov definovanej 
  funkcie alebo predikátu: 
  \def* 
    Tex1_f(E) = Tex0_cdots
    Tex1_f Nd(x,l,r) = Tex0_cdots
  \end

rem 
  \para \bf  \it  Predikát \ft Bt \end.  \end  \end Predikát \ft Bt(t) \end 
  platí, ak \ft t \end je kódom binárneho stromu, teda ak sa dá vytvoriť 
  pomocou konštruktorov \ft E \end a \ft Nd(x,l,r) \end. 

pred Bt 
  Bt(E)
  Bt Nd(x,l,r) <- N(x) & Bt(l) & Bt(r)

rem 
  \para \bf  \it  [CL] Predikát \ft Bt \end ako formát.  \end  \end Keď kód 
  binárneho stromu priradíme premennej v query, implicitne sa zobrazí ako 
  párovací výraz. Vyskúšajte napríklad query: 
  \verbatim 
      Nd(3,E,E) = l & Nd(7,E,E) = r & Nd(5,l,r) = t
  \end
  \para Predikát \ft Bt(t) \end je zadefinovaný tak, aby bol \it  formátom 
   \end – návodom na zobrazovanie hodnôt. Vďaka tomu ho môžeme použiť 
  na zobrazovanie hodnôt v query vo forme binárnych stromov, napríklad: 
  \verbatim 
      Nd(3,E,E) = l:Bt & Nd(7,E,E) = r:Bt & Nd(5,l,r) = t:Bt
      1,9,(0,0),0,0 = t:Bt
      T1 = v & v = t:Bt
  \end

rem 
  \para \bf  \it  Chyby pri kódovaní binárnych stromov.  \end  \end Ak 
  necháme formátom \ft Bt \end zobraziť číslo, ktoré \it  nekóduje  \end 
  binárny strom, vo výsledku sa objavia chybové hlásenia. 
  \para* Častou chybou je použitie číselnej hodnoty v strome priamo, bez 
  skonštruovania uzla ( \ft Nd \end), v ktorom by bola uložená: 
  \verbatim 
      Nd(5,3,7) = t:Bt
  \end
  \para Inou častou chybou je použitie \ft 0 \end namiesto prázdneho stromu 
  \ft E \end: 
  \verbatim 
      Nd(5,Nd(3,0,0),Nd(7,0,0)) = t:Bt
  \end
  \para Správne píšeme: 
  \verbatim 
      Nd(5,Nd(3,E,E),Nd(7,E,E)) = t:Bt
  \end

rem 
  \para \bf  16.2. Operácie na binárnych stromoch  \end 

rem 
  \para \bf  Úloha.  \end Zadefinujte funkciu 
  \ft Tex2_equiv(Sz(t),Tex1_sz(t)) \end, ktorá určí počet uzlov ( 
  \ft Nd \end) v binárnom strome \ft t \end. 
  \para* \header* fun Sz 'Tex1_sz' \end Napríklad \ft Sz Nd(4,E,E) = 1 \end, 
  \ft Sz(T1) = 6 \end. 
  \para* Testovanie: 
  \verbatim 
      Sz_test = r:Results
  \end

fun Sz 'Tex1_sz'
  Sz(t) = Foo

fun/0 Sz_test 
  Sz_test = 
  Check(Sz(E),0),Check(Sz Nd(0,E,E),1),Check(Sz Nd(0,Nd(0,E,E),E),2),
  Check(Sz Nd(0,E,Nd(0,E,E)),2),Check(Sz Nd(0,Nd(0,E,E),Nd(0,E,E)),3),
  Check(Sz(T1),6),0

rem 
  \para \bf  Úloha.  \end Zadefinujte funkciu \ft Reflect(t) \end, ktorá 
  vytvorí zrkadlový obraz binárneho stromu \ft t \end. 
  \para* Napríklad 
  \eq* 
    Reflect Nd(0,Nd(1,Nd(3,E,E),Nd(4,E,E)),Nd(2,E,Nd(6,E,E))) = 
    Nd(0,Nd(2,Nd(6,E,E),E),Nd(1,Nd(4,E,E),Nd(3,E,E)))
  \end
  \para* Testovanie: 
  \verbatim 
      Reflect_test = r:Results_bt
  \end

fun Reflect 
  Reflect(t) = Foo

fun/0 Reflect_test 
  Reflect_test = 
  Check(Reflect(E),E),Check(Reflect Nd(0,E,E),Nd(0,E,E)),
  Check(Reflect Nd(0,Nd(0,E,E),E),Nd(0,E,Nd(0,E,E))),
  Check(Reflect Nd(0,E,Nd(0,E,E)),Nd(0,Nd(0,E,E),E)),
  Check(Reflect Nd(0,Nd(0,E,E),Nd(0,E,E)),Nd(0,Nd(0,E,E),Nd(0,E,E))),
  Check(Reflect(T1),Nd(0,Nd(2,Nd(6,E,E),E),Nd(1,Nd(4,E,E),Nd(3,E,E)))),0

rem 
  \para \bf  Úloha.  \end \header* pred/2 Inbt  \end Zadefinujte predikát 
  \ft Tex2_equiv(Inbt(a,t),Tex2_inbt(a,t)) \end, ktorý platí, ak je hodnota 
  \ft a \end uložená v niektorom uzle stromu \ft t \end. 
  \para* \header* pred/2 Inbt 'Tex2_inbt' \end Napríklad \ft Inbt(3,T1) \end, 
  ale \ft ~Inbt(5,T1) \end. 
  \para* \it  Návod.  \end Predikát má nasledujúce vlastnosti: 
  \eq* 
    ~Inbt(a,E)
  \end
  \eq* 
    Inbt(a,Nd(x,l,r)) <-> a = x \/ Inbt(a,l) \/ Inbt(a,r)
  \end
  \para Pri definícii predikátu nie je možné použiť disjunkciu. Využite 
  diskrimináciu na platnosť a neplatnosť predikátu. Negáciu (neplatnosť) 
  predikátu zapisujeme symbolom ~ (napr. ~Inbt(a,t)). 
  \para* Testovanie: 
  \verbatim 
      Inbt_test = r:Results
  \end

pred/2 Inbt 'Tex2_inbt'
  Inbt(a,t) <- Quux

fun/2 Inbt_ 'Tex2_inbt_'
  Inbt_(a,t) = 0 <- ~Inbt(a,t)
  Inbt_(a,t) = 1 <- Inbt(a,t)

fun/0 Inbt_test 
  Inbt_test = 
  Check(Inbt_(0,E),0),Check(Inbt_(0,Nd(0,E,E)),1),Check(Inbt_(1,Nd(0,E,E)),0),
  Check(Inbt_(1,Nd(0,Nd(1,E,E),E)),1),Check(Inbt_(1,Nd(0,E,Nd(1,E,E))),1),
  Check(Inbt_(2,Nd(0,Nd(1,E,E),E)),0),Check(Inbt_(2,Nd(0,E,Nd(1,E,E))),0),
  Check(Inbt_(4,T1),1),Check(Inbt_(5,T1),0),0

rem 
  \para \bf  Úloha.  \end Zadefinujte funkcie \ft Inorder(t) \end, 
  \ft Preorder(t) \end a \ft Postorder(t) \end, ktoré vytvoria zoznam hodnôt 
  uložených v uzloch binárneho stromu \ft t \end v príslušnom poradí. 
  \para* Napríklad pre 
  \eq* 
    T1 = Nd(0,Nd(1,Nd(3,E,E),Nd(4,E,E)),Nd(2,E,Nd(6,E,E)))
  \end
  \para* platí \ft Inorder(T1) = 3,1,4,0,2,6,0 \end; 
  \ft Preorder(T1) = 0,1,3,4,2,6,0 \end; \ft Postorder(T1) = 3,4,1,6,2,0,0 \end. 
  \para* Testovanie: 
  \verbatim 
      Inorder_test = r:Results
  \end

fun Inorder 
  Inorder(t) = Foo

fun/0 Inorder_test 
  Inorder_test = 
  Check(Inorder(E),0),Check(Inorder Nd(0,E,E),0,0),
  Check(Inorder Nd(0,Nd(1,E,E),E),1,0,0),Check(Inorder Nd(0,E,Nd(1,E,E)),0,1,0),
  Check(Inorder Nd(0,Nd(2,E,E),Nd(1,E,E)),2,0,1,0),
  Check(Inorder(T1),3,1,4,0,2,6,0),0

rem 
  \para* Testovanie: 
  \verbatim 
      Preorder_test = r:Results
  \end

fun Preorder 
  Preorder(t) = Foo

fun/0 Preorder_test 
  Preorder_test = 
  Check(Preorder(E),0),Check(Preorder Nd(0,E,E),0,0),
  Check(Preorder Nd(0,Nd(1,E,E),E),0,1,0),
  Check(Preorder Nd(0,E,Nd(1,E,E)),0,1,0),
  Check(Preorder Nd(0,Nd(2,E,E),Nd(1,E,E)),0,2,1,0),
  Check(Preorder(T1),0,1,3,4,2,6,0),0

rem 
  \para* Testovanie: 
  \verbatim 
      Postorder_test = r:Results
  \end

fun Postorder 
  Postorder(t) = Foo

fun/0 Postorder_test 
  Postorder_test = 
  Check(Postorder(E),0),Check(Postorder Nd(0,E,E),0,0),
  Check(Postorder Nd(0,Nd(1,E,E),E),1,0,0),
  Check(Postorder Nd(0,E,Nd(1,E,E)),1,0,0),
  Check(Postorder Nd(0,Nd(2,E,E),Nd(1,E,E)),2,1,0,0),
  Check(Postorder(T1),3,4,1,6,2,0,0),0

rem 
  \para \bf  Úloha.  \end \header* fun/2 Inordera  \end Zadefinujte funkciu 
  \ft Inordera(t,as) \end, ktorá \it  bez použitia zreťazenia  \end vytvorí 
  zoznam hodnôt uložených v uzloch binárneho stromu \ft t \end v poradí 
  inorder nasledovaný zoznamom \ft as \end. 
  \para* Napríklad 
  \ft Inordera(Nd(0,Nd(1,E,E),Nd(2,E,E)),98,99,0) = 1,0,2,98,99,0 \end a 
  \ft Inordera(T1,98,99,0) = 3,1,4,0,2,6,98,99,0 \end. 
  \para* Funkcia má vlastnosť 
  \eq (*)
    Bt(t) -> Inordera(t,as) = Inorder(t)++as
  \end
  \para a teda 
  \eq* 
    Bt(t) -> Inordera(t,0) = Inorder(t)
  \end
  \para Nepoužite zreťazenie (++) ani žiadne pomocné funkcie. 
  \para* Predstavte si zoznam \ft as \end ako zásobník, na ktorý postupne 
  ukladáte hodnoty zo stromu \ft t \end od poslednej po prvú. 
  \para* Definíciu funkcie \ft Inordera \end tiež môžete odvodiť 
  z definície funkcie \ft Inorder \end a z vlastnosti (*). 
  \para* Testovanie: 
  \verbatim 
      Inordera_test = r:Results
  \end

fun/2 Inordera 
  Inordera(t,as) = Foo

fun/0 Inordera_test 
  Inordera_test = 
  Check(Inordera(E,0),0),Check(Inordera(E,98,99,0),98,99,0),
  Check(Inordera(Nd(0,E,E),98,99,0),0,98,99,0),
  Check(Inordera(Nd(0,Nd(1,E,E),E),98,99,0),1,0,98,99,0),
  Check(Inordera(Nd(0,E,Nd(1,E,E)),98,99,0),0,1,98,99,0),
  Check(Inordera(Nd(0,Nd(1,E,E),Nd(2,E,E)),98,99,0),1,0,2,98,99,0),
  Check(Inordera(T1,98,99,0),3,1,4,0,2,6,98,99,0),0

rem 
  \para \bf  Úloha.  \end \header* fun/2 Preordera  \end 
  \header* fun/2 Postordera  \end Podobne ako v predchádzajúcej úlohe 
  zadefinujte funkcie \ft Preordera(t,as) \end a \ft Postordera(t,as) \end 
  s vlastnosťami 
  \eq* 
    Bt(t) -> Preordera(t,as) = Preorder(t)++as
  \end
  \eq* 
    Bt(t) -> Postordera(t,as) = Postorder(t)++as
  \end
  \para bez použitia zreťazenia alebo pomocných funkcií. 
  \para* Testovanie: 
  \verbatim 
      Preordera_test = r:Results
  \end

fun/2 Preordera 
  Preordera(t,as) = Foo

fun/0 Preordera_test 
  Preordera_test = 
  Check(Preordera(E,0),0),Check(Preordera(E,98,99,0),98,99,0),
  Check(Preordera(Nd(0,E,E),98,99,0),0,98,99,0),
  Check(Preordera(Nd(0,Nd(1,E,E),E),98,99,0),0,1,98,99,0),
  Check(Preordera(Nd(0,E,Nd(1,E,E)),98,99,0),0,1,98,99,0),
  Check(Preordera(Nd(0,Nd(1,E,E),Nd(2,E,E)),98,99,0),0,1,2,98,99,0),
  Check(Preordera(T1,98,99,0),0,1,3,4,2,6,98,99,0),0

rem 
  \para* Testovanie: 
  \verbatim 
      Postordera_test = r:Results
  \end

fun/2 Postordera 
  Postordera(t,as) = Foo

fun/0 Postordera_test 
  Postordera_test = 
  Check(Postordera(E,0),0),Check(Postordera(E,98,99,0),98,99,0),
  Check(Postordera(Nd(0,E,E),98,99,0),0,98,99,0),
  Check(Postordera(Nd(0,Nd(1,E,E),E),98,99,0),1,0,98,99,0),
  Check(Postordera(Nd(0,E,Nd(1,E,E)),98,99,0),1,0,98,99,0),
  Check(Postordera(Nd(0,Nd(1,E,E),Nd(2,E,E)),98,99,0),1,2,0,98,99,0),
  Check(Postordera(T1,98,99,0),3,4,1,6,2,0,98,99,0),0

rem 
  \para \bf  Prémiová domáca úloha \it  du11a  \end.  \end (2 body) 
  \para Hodnotiť budeme prvé 3 správne riešenia z každého termínu 
  cvičení. Ďalšie pravidlá pre prémiové domáce úlohy nájdete na \it  
  http://dai.fmph.uniba.sk/courses/udp/#pdu  \end. 
  \para* \it  Zadanie.  \end \header* pred/2 Subtree  \end Zadefinujte predikát 
  \ft Tex2_equiv(Subtree(s,t),Tex2_subtree(s,t)) \end, ktorý platí, ak 
  \ft s \end je podstromom stromu \ft t \end. 
  \para* \it  Príklady.  \end \header* pred/2 Subtree 'Tex2_subtree' \end 
  Predikát platí napríklad v nasledujúcich prípadoch: 
  \eq* 
    Subtree(E,Nd(5,E,E)) & 
    Subtree(Nd(2,E,Nd(6,E,E)),Nd(0,Nd(1,Nd(3,E,E),Nd(4,E,E)),Nd(2,E,Nd(6,E,E)))) & 
    Subtree(T1,T1)
  \end
  \para Predikát neplatí napríklad v prípadoch: 
  \eq* 
    ~Subtree(Nd(5,E,E),E) & ~Subtree(Nd(2,E,E),Nd(2,E,Nd(6,E,E))) & 
    ~Subtree(Nd(0,Nd(3,E,E),Nd(4,E,E)),
             Nd(0,Nd(1,Nd(3,E,E),Nd(4,E,E)),Nd(2,E,Nd(6,E,E))))
  \end
  \para \it  Návod.  \end Podobne ako pri predikáte \ft Inbt(a,t) \end 
  využite, že predikát \ft Subtree(s,t) \end má nasledujúcu vlastnosť: 
  \eq* 
    Subtree(s,t) <-> 
    s = t \/ \e x\e l\e r(t = Nd(x,l,r) & (Subtree(s,l) \/ Subtree(s,r)))
  \end
  \para \it  Testovanie.  \end 
  \verbatim 
      Subtree_test = r:Results
  \end

pred/2 Subtree 'Tex2_subtree'
  Subtree(s,t) <- Quux

fun/2 Subtree_ 'Tex2_subtree_'
  Subtree_(s,t) = 0 <- ~Subtree(s,t)
  Subtree_(s,t) = 1 <- Subtree(s,t)

fun/0 Subtree_test 
  Subtree_test = 
  Check(Subtree_(E,Nd(5,E,E)),1),Check(Subtree_(Nd(2,E,Nd(6,E,E)),T1),1),
  Check(Subtree_(T1,T1),1),Check(Subtree_(Nd(5,E,E),E),0),
  Check(Subtree_(Nd(2,E,E),Nd(2,E,Nd(6,E,E))),0),
  Check(Subtree_(Nd(0,Nd(3,E,E),Nd(4,E,E)),T1),0),0

